﻿using System;
using System.Drawing;
using System.Windows.Forms;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Styles;
using ThinkGeo.MapSuite.WinForms;

namespace wform1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {   
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;

            LayerOverlay layerOverlay = new LayerOverlay();
            ShapeFileFeatureLayer shapeFileLayer = new ShapeFileFeatureLayer(@"..\..\AppData\states.shp");
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = WorldStreetsAreaStyles.Forest();
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            layerOverlay.Layers.Add(shapeFileLayer);
            winformsMap1.Overlays.Add(layerOverlay);

            SimpleMarkerOverlay markerOverlay = new SimpleMarkerOverlay();
            markerOverlay.MapControl = winformsMap1;
            winformsMap1.Overlays.Add("markerOverlay", markerOverlay);

            shapeFileLayer.Open();
            winformsMap1.CurrentExtent = shapeFileLayer.GetBoundingBox();

            winformsMap1.MapClick += WinformsMap1_MapClick;
            winformsMap1.Refresh();
        }

        private void WinformsMap1_MapClick(object sender, MapClickWinformsMapEventArgs e)
        {
            SimpleMarkerOverlay markerOverlay = winformsMap1.Overlays["markerOverlay"] as SimpleMarkerOverlay;

            Marker marker = new Marker(e.WorldX, e.WorldY);
            Image icon = Image.FromFile(@"..\..\AppData\CoffeeShop.png");
            Bitmap item = new Bitmap(icon, new Size(20, 20));
            marker.Image = item;
            marker.ToolTipText = "Lat: " + e.WorldX + "°N Lon: " + e.WorldY + "°E";
            marker.Width = 20;
            marker.Height = 20;
            marker.YOffset = -17;
            marker.Visible = true;

            markerOverlay.Markers.Clear();
            markerOverlay.Markers.Add(marker);

            winformsMap1.Refresh();
        }
    }
}
